/** \file close_session.cpp  
*COPYRIGHT (C) 2006  Michele Basso   (basso@dsi.unifi.it)
*                    Marco Romagnoli (romagnoli@control.dsi.unifi.it)
*                    Massimo Vassalli(vassalli@inoa.it)

This library is free software; you can redistribute it and/or
modify it under the terms of the GNU Lesser General Public
License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version.

This library is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public
License along with this library; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
*/

#include "XmlRpc.h"

#include <iostream>
//sleep include
#include <unistd.h>

using namespace XmlRpc;

int portXML=29000;
std::string server="localhost";

int main(int argc, char* argv[])
{
  std::string from_server;
  
  XmlRpcClient c(server.c_str(), portXML);
  XmlRpcValue noArgs, result;
  noArgs[0]="Master";
  noArgs[1]=argv[1];

  std::cout << "Before Close_Session\n";
  if (c.execute("Close_Session", noArgs, result))
    std::cout << result << "\n";
  else {
    std::cout << "Error calling 'Close_Session'\n\n";
    exit(1);
  }
  std::cout << "After Close_Session\n";
  
  return 0;
}
