/**
*COPYRIGHT (C) 2006  Michele Basso   (basso@dsi.unifi.it)
*                    Marco Romagnoli (romagnoli@control.dsi.unifi.it)
*                    Massimo Vassalli(vassalli@inoa.it)
*
*This library is free software; you can redistribute it and/or
*modify it under the terms of the GNU Lesser General Public
*License as published by the Free Software Foundation; either
*version 2 of the License, or (at your option) any later version.
*
*This library is distributed in the hope that it will be useful,
*but WITHOUT ANY WARRANTY; without even the implied warranty of
*MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
*Lesser General Public License for more details.
*
*You should have received a copy of the GNU Lesser General Public
*License along with this library; if not, write to the Free Software
*Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
**/

#include "XmlRpc.h"
#include "../socket/Socket.h"
#include "../socket/SocketException.h"
#include <iostream>
//serve per la sleep
#include <unistd.h>

using namespace XmlRpc;

int main(int argc, char* argv[])
{
/*  struct sockaddr_in saddr;
  memset(&saddr, 0, sizeof(saddr));
  saddr.sin_family = AF_INET;

  struct hostent *hp = gethostbyname(host.c_str());
  if (hp == 0) return false;

  saddr.sin_family = hp->h_addrtype;
  memcpy(&saddr.sin_addr, hp->h_addr, hp->h_length);
  saddr.sin_port = htons((u_short) port);
*/  
  
  int port_xml=29001;
  std::string server="192.168.0.2";
  int port_socket=30000;
  std::string data_from_server;
  Socket data_sock;
  int status;
  XmlRpcClient c(server.c_str(), port_xml);
  XmlRpcValue noArgs, result;

  for(int i=0;i<1;i++) {
	  data_sock.create();
	/************ CONNECT TARGET *************************/
	  std::cout << "prima di connect_target\n";
	  noArgs.clear();
	  noArgs[0]="IFTASK";
	  if (c.execute("tConnect", noArgs, result))
	    std::cout << result << "\n";
	  else {
	    std::cout << "Error calling 'Connect_Target'\n\n";
	    exit(1);
	  }
	  std::cout << "dopo connect_target\n";
	/*******************************************************/
	/************ SEND DATA TARGET *************************
	  noArgs.clear();
	  noArgs[0]="IFTASK";
	  noArgs[1]=1;
	  noArgs[2]=3;
	  if (c.execute("Start_Data", noArgs, result))
	    std::cout << result << "\n";
	  else {
	    std::cout << "Error calling 'Start_Data'\n\n";
	    exit(1);
	  }
	  std::cout << "dopo Start_Data\n";
	/*******************************************************/	
	/************ SEND DATA TARGET *************************/
	  noArgs.clear();
	  noArgs[0]="IFTASK";
	  noArgs[1]=0;
	  noArgs[2]=1;
	  if (c.execute("Start_Data", noArgs, result))
	    std::cout << result << "\n";
	  else {
	    std::cout << "Error calling 'Start_Data'\n\n";
	    exit(1);
	  }
	  std::cout << "dopo Start_Data\n";
	/*******************************************************/	
	/************* SOCKET     *****************************/
	  std::cout << "prima di connect\n";
	  if(!data_sock.connect(server,port_socket))
		std::cout << "Errore nel connetersi al socket dei dati\n";
	  std::cout << "dopo connect\n";
	//	sleep(10);
	/*******************************************************/
	  data_sock.toString();
	  std::cout << "prima di recv\n";
	  for(int i=0;i<2000000;i++) {
		  status=data_sock.recv(data_from_server);
		  if(status==-1)
		  	std::cout << "errore in ricezione";
		  else if(status==0)
		  	std::cout << "Nessun dato ricevuto\n";
		  else
		  	std::cout << data_from_server;
	  }
	//  fflush(stdin);
	//  fflush(stdout);
	  std::cout << "dopo recv\n";
	  data_sock.reset();
  }

  return 0;
}
